View Issue Details

IDProjectCategoryView StatusLast Update
0002281OpenFOAM[All Projects] Bugpublic2016-10-05 20:41
ReporterdkokronAssigned Tohenry 
PrioritynormalSeveritycrashReproducibilityalways
Status closedResolutionno change required 
PlatformFedora 24 x86_64OSFedora 24OS Version4.7.4-200.fc24
Product Version 
Fixed in Version 
Summary0002281: OpenFOAM-4.x build failure with Intel(R) 64, Version 17.0.0.098 Build 20160721
DescriptionOpenFOAM-4.x (updated today 3 Oct. 2016) fails to compile with Intel 2017.0.098 on my fedora 24 system.

icpc -std=c++0x -fp-trap=common -fp-model precise -Dlinux64 -DWM_ARCH_OPTION=64 -DWM_DP -DWM_LABEL_SIZE=32 -Wall -Wextra -Wnon-virtual-dtor -Wno-unused-parameter -Wno-invalid-offsetof -diag-disable 654,1125,2304 -O3 -DNoRepository -DFOAM_USE_INOTIFY -IlnInclude -I. -I/home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude -I/home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OSspecific/POSIX/lnInclude -fPIC -c signals/sigStopAtWriteNow.C -o /home/dkokron/OpenFOAM/OpenFOAM-4.x/platforms/linux64IccDPInt32Opt/src/OSspecific/POSIX/signals/sigStopAtWriteNow.o
In file included from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.C(26),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.H(405),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/scalarField.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionSet.H(46),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedType.H(40),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedScalar.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/TimeState.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Time.H(47),
                 from signals/sigStopAtWriteNow.C(30):
/home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/FieldMapper.H(79): warning #327: NULL reference is not allowed
              return *reinterpret_cast<mapDistributeBase*>(NULL);
                     ^

In file included from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/MatrixSpace.H(322),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Tensor.H(45),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/SymmTensorI.H(27),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/SymmTensor.H(155),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/symmTensor.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/fieldTypes.H(37),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/flipOp.H(40),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/mapDistributeBaseTemplates.C(29),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/mapDistributeBase.H(488),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.C(30),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.H(405),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/scalarField.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionSet.H(46),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedType.H(40),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedScalar.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/TimeState.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Time.H(47),
                 from signals/sigStopAtWriteNow.C(30):
/home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/MatrixSpaceI.H(494): warning #2357: "Foam::MatrixSpace<Form2, Cmpt, SubTensor::mRows, SubTensor::nCols>" cannot be specified in a template member definition -- "Foam::MatrixSpace<Form, Cmpt, Mrows, Ncols>" assumed instead
      const MatrixSpace<Form2, Cmpt, SubTensor::mRows, SubTensor::nCols>& matrix
            ^

In file included from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/MatrixSpace.H(322),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Tensor.H(45),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/SymmTensorI.H(27),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/SymmTensor.H(155),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/symmTensor.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/fieldTypes.H(37),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/flipOp.H(40),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/mapDistributeBaseTemplates.C(29),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/mapDistributeBase.H(488),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.C(30),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Field.H(405),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/scalarField.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionSet.H(46),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedType.H(40),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/dimensionedScalar.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/TimeState.H(38),
                 from /home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/Time.H(47),
                 from signals/sigStopAtWriteNow.C(30):
/home/dkokron/OpenFOAM/OpenFOAM-4.x/src/OpenFOAM/lnInclude/MatrixSpaceI.H(492): error: no instance of overloaded function "Foam::MatrixSpace<Form, Cmpt, Mrows, Ncols>::Block<SubTensor, BRowStart, BColStart>::operator=" matches the specified type
  operator=
  ^

compilation aborted for signals/sigStopAtWriteNow.C (code 2)
/home/dkokron/OpenFOAM/OpenFOAM-4.x/wmake/rules/General/transform:8: recipe for target '/home/dkokron/OpenFOAM/OpenFOAM-4.x/platforms/linux64IccDPInt32Opt/src/OSspecific/POSIX/signals/sigStopAtWriteNow.o' failed
make: *** [/home/dkokron/OpenFOAM/OpenFOAM-4.x/platforms/linux64IccDPInt32Opt/src/OSspecific/POSIX/signals/sigStopAtWriteNow.o] Error 2
Additional Informationgit status
On branch master
Your branch is up-to-date with 'origin/master'.

This version did build under Intel-2016 update 2.
TagsNo tags attached.

Activities

henry

2016-10-03 23:25

manager   ~0006955

Try OpenFOAM-dev

paul

2016-10-04 08:59

reporter  

OpenFOAM_IntelCompiler2017.patch (1,449 bytes)
diff --git a/src/OpenFOAM/primitives/MatrixSpace/MatrixSpace.H b/src/OpenFOAM/primitives/MatrixSpace/MatrixSpace.H
index f06874f..4e47c92 100644
--- a/src/OpenFOAM/primitives/MatrixSpace/MatrixSpace.H
+++ b/src/OpenFOAM/primitives/MatrixSpace/MatrixSpace.H
@@ -172,7 +172,15 @@ public:
                     SubTensor::mRows,
                     SubTensor::nCols
                 >& matrix
-            );
+            ){
+    for (direction i=0; i<mRows; ++i)
+    {
+        for (direction j=0; j<nCols; ++j)
+        {
+            operator()(i,j) = matrix(i,j);
+        }
+    }
+}
 
             //- Assignment to a column vector
             template<class VSForm>
diff --git a/src/OpenFOAM/primitives/MatrixSpace/MatrixSpaceI.H b/src/OpenFOAM/primitives/MatrixSpace/MatrixSpaceI.H
index 207162b..3fc46dd 100644
--- a/src/OpenFOAM/primitives/MatrixSpace/MatrixSpaceI.H
+++ b/src/OpenFOAM/primitives/MatrixSpace/MatrixSpaceI.H
@@ -482,7 +482,7 @@ inline void Foam::MatrixSpace<Form, Cmpt, Mrows, Ncols>::operator=
     }
 }
 
-
+#if 0
 template<class Form, class Cmpt, Foam::direction Mrows, Foam::direction Ncols>
 template<class SubTensor, Foam::direction BRowStart, Foam::direction BColStart>
 template<class Form2>
@@ -502,7 +502,7 @@ operator=
         }
     }
 }
-
+#endif
 
 template<class Form, class Cmpt, Foam::direction Mrows, Foam::direction Ncols>
 template<class SubTensor, Foam::direction BRowStart, Foam::direction BColStart>

paul

2016-10-04 09:01

reporter   ~0006958

There was a bug in the Intel compiler front end which has now been fixed. Anything with a timestamp after 20160804 should include the fix. If you cannot get a more recent version then you can apply the patch I have attached.

Best regards,
Paul

dkokron

2016-10-04 16:47

reporter   ~0006960

OpenFOAM-dev without the patch from Paul, has the same compile failure as 4.x.

OpenFOAM-4.x with the patch from Paul compiles under 17.0.0.098 Build 20160721.

Thanks Paul.
Please close this ticket.
Dan

Issue History

Date Modified Username Field Change
2016-10-03 22:12 dkokron New Issue
2016-10-03 23:25 henry Note Added: 0006955
2016-10-04 08:59 paul File Added: OpenFOAM_IntelCompiler2017.patch
2016-10-04 09:01 paul Note Added: 0006958
2016-10-04 16:47 dkokron Note Added: 0006960
2016-10-04 16:54 henry Assigned To => henry
2016-10-04 16:54 henry Status new => closed
2016-10-04 16:54 henry Resolution open => no change required